import java.awt.Dimension;

import javax.media.j3d.BoundingSphere;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.PointLight;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.swing.JFrame;
import javax.vecmath.AxisAngle4d;
import javax.vecmath.Vector3d;

import stereoView.StereoCanvas;
import stereoView.StereoFrame;

import com.sun.j3d.utils.behaviors.vp.OrbitBehavior;
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.SimpleUniverse;

/**
 * 
 * @author bjoern
 *
 */
public class StartNoStereo {

	/**
	 * 
	 * @param argv
	 */
	public static void main(String argv[]) {
		
		// *****************
		// initial variables
		// *****************
		
		// size of the canvas
		Dimension canvasDimensions = new Dimension(1000,1000);

		
		// **********************
		// construct the universe
		// **********************
		
		// the canvas of the universe
		Canvas3D canvas = new Canvas3D(SimpleUniverse.getPreferredConfiguration());
		
		// construct a simple universe
		SimpleUniverse universe = new SimpleUniverse(canvas);

		// construct the root branchgroup
		BranchGroup bgRoot= new BranchGroup();
		bgRoot.setCapability(BranchGroup.ALLOW_DETACH);
		
		// construct the initial 3D component, transform it and add it
		TransformGroup tgCube = new TransformGroup();
		tgCube.addChild(new ColorCube(0.1));
		Transform3D t3dCube = new Transform3D();
//		t3dCube.set(new AxisAngle4d(1,1,0,45));
		t3dCube.set(new Vector3d(0,0,1));
		tgCube.setTransform(t3dCube);
		bgRoot.addChild(tgCube);
		
		// construct the initial 3D component, transform it and add it
		TransformGroup tgCube2 = new TransformGroup();
		tgCube2.addChild(new ColorCube(0.1));
		Transform3D t3dCube2 = new Transform3D();
//		t3dCube.set(new AxisAngle4d(1,1,0,45));
		t3dCube2.set(new Vector3d(0,0,-1));
		tgCube2.setTransform(t3dCube2);
		bgRoot.addChild(tgCube2);
		
		// create the light and add it 
		PointLight pointLight = new PointLight();
		TransformGroup tgLight = new TransformGroup();
		BranchGroup bgLight = new BranchGroup();	
		tgLight.addChild(pointLight);
		bgLight.addChild(tgLight);
		universe.addBranchGraph(bgLight);
		
		// add the root branch to the universe
		universe.addBranchGraph(bgRoot);
		universe.getViewingPlatform().setNominalViewingTransform();
		
		// add the OrbitBehavior to the canvas
		OrbitBehavior orbit = new OrbitBehavior(canvas);
		orbit.setSchedulingBounds(new BoundingSphere());
		universe.getViewingPlatform().setViewPlatformBehavior(orbit);
		
		// init the JFrame
		JFrame jFrame = new JFrame();
		jFrame.setVisible(true);
		jFrame.setSize(canvasDimensions);
		jFrame.add(canvas);
		
	}
	
}