package stereoView;

import javax.media.j3d.Canvas3D;
import javax.media.j3d.Node;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.ViewPlatform;
import javax.vecmath.Point3d;
import javax.vecmath.Vector3d;

import com.sun.j3d.utils.universe.ViewInfo;

public class EyeFocus {

	Canvas3D canvas = null;
	Node focus_node = null;
	
	public EyeFocus(Canvas3D canvas) {
		this(canvas, null);
	}
	
	public EyeFocus(Canvas3D canvas, Node focus_node) {
		this.canvas = canvas;
		this.focus_node = focus_node;
	}
	
	public void updateEyes() {
		if (!canvas.getStereoEnable())
			return;
		
		if (focus_node == null)
			return;
		
		Point3d tmp = new Point3d();
		Point3d eye_l = new Point3d();
		Point3d eye_r = new Point3d();
		Transform3D eye_l_t3d = new Transform3D();
		Transform3D eye_r_t3d = new Transform3D();
		
		Point3d point = new Point3d();
		Transform3D t3d = new Transform3D();
		
		ViewInfo viewInfo = new ViewInfo(canvas.getView());
		
		viewInfo.getEyeToVworld(canvas, eye_l_t3d, eye_r_t3d);

		eye_l_t3d.transform(eye_l);
		eye_r_t3d.transform(eye_r);
		
		System.out.println("Left: " + eye_l);
		System.out.println("Right: " + eye_r);
		
		tmp.set(eye_l);
		tmp.add(eye_r);
		tmp.scale(0.5d);
		eye_l.set(tmp);
		System.out.println("Center: " + eye_l);
		
		focus_node.getLocalToVworld(t3d);
		t3d.transform(point);
		
		Transform3D look = new Transform3D();
		Vector3d orient = new Vector3d(0.0d, 0.0d, 1.0d);
		look.lookAt(eye_l, point, orient);
		look.invert();
		
		ViewPlatform vp = canvas.getView().getViewPlatform();
		TransformGroup g = (TransformGroup) vp.getParent();
		g.setTransform(look);
		
		Node n = vp;		
		while (n.getParent() != null) {
			System.out.println(n.getParent().getClass().getName());
			
			n = n.getParent();
		}
		
	}
	
	public void setFocusObject(Node focus_obj){
		this.focus_node = focus_obj;
	}
	
}
