package stereoView;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.media.j3d.Canvas3D;
import javax.media.j3d.View;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

public class MonoscopicPreferencesPanel extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	Canvas3D canvas = null;

	public MonoscopicPreferencesPanel(Canvas3D canvas){
		this.canvas = canvas;
		
		JPanel box = new JPanel();
		box.setLayout(new BoxLayout(box, BoxLayout.Y_AXIS));
		
		ButtonGroup radio_buttons = new ButtonGroup();
		
		JRadioButton left_eye = new JRadioButton("Left Eye");
		JRadioButton cyclopean_eye = new JRadioButton("Cyclopean Eye");
		JRadioButton right_eye = new JRadioButton("Right Eye");
		
		radio_buttons.add(left_eye);
		radio_buttons.add(cyclopean_eye);
		radio_buttons.add(right_eye);
		
		left_eye.addActionListener(new L_eye_Listener());
		cyclopean_eye.addActionListener(new C_eye_Listener());
		right_eye.addActionListener(new R_eye_Listener());
		
		box.add(left_eye);
		box.add(cyclopean_eye);
		box.add(right_eye);
		
		this.add(box);
		
	}

	public void actionPerformed(ActionEvent e) {
		System.out.println(e);		
	}

	private class L_eye_Listener implements ActionListener {

		public void actionPerformed(ActionEvent e) {
			canvas.setMonoscopicViewPolicy(View.LEFT_EYE_VIEW);
		}
		
	}
	
	private class R_eye_Listener implements ActionListener {

		public void actionPerformed(ActionEvent e) {
			canvas.setMonoscopicViewPolicy(View.RIGHT_EYE_VIEW);
		}
		
	}
	
	private class C_eye_Listener implements ActionListener {

		public void actionPerformed(ActionEvent e) {
			canvas.setMonoscopicViewPolicy(View.CYCLOPEAN_EYE_VIEW);
		}
		
	}
}
