package stereoView;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Toolkit;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.media.j3d.BranchGroup;
import javax.media.j3d.Canvas3D;
import javax.swing.JCheckBox;
import javax.swing.JPanel;

import com.sun.j3d.utils.universe.SimpleUniverse;

public class StereoEnablePanel extends JPanel implements ActionListener{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	Canvas3D canvas = null;
	Dimension c_size = null;
	Container c = null;
	JCheckBox stereo_enabled = null;
	JCheckBox fullscreen = null;
	
	SimpleUniverse u;
	
	BranchGroup r;
	
	Window full = null;
	
	public StereoEnablePanel(Canvas3D canvas, BranchGroup branchGroupForDetach, 
			SimpleUniverse simpleUniverse){
		this.canvas = canvas;
		this.r = branchGroupForDetach;
		this.u = simpleUniverse;
		
		stereo_enabled = new JCheckBox("StereoEnabled");
		fullscreen = new JCheckBox("Fullscreen");
		
		// disable Stereo Enable Checkbox if stereo is not available
		if (canvas.getStereoAvailable() == false) {
			stereo_enabled.setEnabled(false);
			stereo_enabled.setSelected(false);
		} else {
			stereo_enabled.setSelected(canvas.getStereoEnable());
		}
		
		stereo_enabled.addActionListener(this);
		fullscreen.addActionListener(this);
		this.add(stereo_enabled);
		this.add(fullscreen);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == stereo_enabled) 
			canvas.setStereoEnable(stereo_enabled.isSelected());
		else if (e.getSource() == fullscreen) {
			c = canvas.getParent();
			c_size = canvas.getSize();
			BranchGroup t = r;
			t.detach();
//			t.addChild(new FullscreenQuitBehavior());
			u.addBranchGraph(t);
			Toolkit tk = Toolkit.getDefaultToolkit();
			Dimension d = tk.getScreenSize();
			Frame f = new Frame();
			full = new Window(f);
			full.setSize(d);
			full.add(canvas);
			full.setVisible(true);
		}
	}

	public void setFullscreen(boolean b) {
		full.setVisible(b);
		fullscreen.setSelected(b);
		canvas.setSize(c_size);
		c.add(canvas);
	}
}
