package stereoView;

import javax.media.j3d.BranchGroup;
import javax.media.j3d.Node;
import javax.swing.JFrame;

import com.sun.j3d.utils.universe.SimpleUniverse;

public class StereoFrame extends JFrame{

	private static final long serialVersionUID = 1410758566504421778L;
	
	private StereoPanel panel = null;
	
	public StereoFrame(StereoCanvas canvas, BranchGroup branchGroupForDetach,
						SimpleUniverse simpleUniverse) {
		this.panel = new StereoPanel(canvas, branchGroupForDetach, simpleUniverse);
		this.setTitle("StereoView");
		this.add(panel);
		this.pack();
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		if (canvas.getStereoAvailable()) {
			this.setVisible(true);
			System.out.println("StereoView enabled.\n Please use the StereoView window to adjust the settings.\n");
		} else {
			this.setVisible(false);
			System.out.println("StereoView disabled.\n If you have a compatible stereo device like the\n nVidia Quadro FX cards and installed an actual driver,\n please add to your VM arguments:\n -Dj3d.stereo=PREFERRED\n and enable stereo at your graphic driver.\n");
		}
	} 

	public void setFullscreen(boolean b) {
		panel.setFullscreen(b);		
	}
	
	public void setFocus(Node obj) {
		panel.setFocus(obj);
	}
}

