package stereoView;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.media.j3d.BranchGroup;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.Node;
import javax.swing.JPanel;

import com.sun.j3d.utils.universe.SimpleUniverse;

public class StereoPanel extends JPanel{

	private static final long serialVersionUID = -4739705500049820260L;
	
	Canvas3D canvas = null;
	StereoEnablePanel se = null;
	StereoPreferencesPanel pe = null;
	
	public StereoPanel(StereoCanvas canvas, BranchGroup branchGroupForDetach,
						SimpleUniverse simpleUniverse) {
//		System.out.println("Stereo available: " + canvas.getStereoAvailable());
		se = new StereoEnablePanel(canvas, branchGroupForDetach, simpleUniverse);
		pe = new StereoPreferencesPanel(canvas);
		this.canvas = canvas;
		this.setLayout(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.VERTICAL;
		c.anchor = GridBagConstraints.LINE_START;
		c.gridx = 0;
		c.gridy = 0;
		this.add(se, c);
		c.gridy = 1;
		this.add(new MonoscopicPreferencesPanel(canvas), c);
		c.gridy = 2;
//		this.add(new ViewingPolicyPanel(canvas), c);
//		c.gridy = 3;
		this.add(pe, c);
		
		canvas.setPrefs(pe);
	}

	public void setFullscreen(boolean b) {
		se.setFullscreen(b);
	}	
	
	public void setFocus(Node obj) {
		pe.setFocusObject(obj);
	}
	
}

