package stereoView;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.media.j3d.Canvas3D;
import javax.media.j3d.View;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

public class ViewingPolicyPanel extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	Canvas3D canvas;

	public ViewingPolicyPanel(Canvas3D canvas) {
		this.canvas = canvas;
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		ButtonGroup radio_buttons = new ButtonGroup();
		
		JRadioButton rel_wind = new JRadioButton("Relative_TO_WINDOW");
		JRadioButton rel_fov = new JRadioButton("Relative_TO_FIELD_OF_VIEW");
		JRadioButton rel_coex = new JRadioButton("Relative_TO_COEXISTENCE");
		JRadioButton rel_screen = new JRadioButton("Relative_TO_SCREEN");
		
		rel_wind.addActionListener(new Rel_Wind());
		rel_fov.addActionListener(new Rel_Fov());
		rel_coex.addActionListener(new Rel_Coex());
		rel_screen.addActionListener(new Rel_Screen());
		
		radio_buttons.add(rel_wind);
		radio_buttons.add(rel_fov);
		radio_buttons.add(rel_coex);
		radio_buttons.add(rel_screen);		

		this.add(rel_wind);
		this.add(rel_screen);
		this.add(rel_fov);
		this.add(rel_coex);
	}
	
	private class Rel_Wind implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			canvas.getView().setWindowEyepointPolicy(View.RELATIVE_TO_WINDOW);
			updateEyes();
		}
	}
	
	private class Rel_Screen implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			canvas.getView().setWindowEyepointPolicy(View.RELATIVE_TO_SCREEN);
			updateEyes();
		}
	}
	
	private class Rel_Coex implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			canvas.getView().setWindowEyepointPolicy(View.RELATIVE_TO_COEXISTENCE);
			updateEyes();
		}
	}
	
	private class Rel_Fov implements ActionListener{
		public void actionPerformed(ActionEvent e) {
			canvas.getView().setWindowEyepointPolicy(View.RELATIVE_TO_FIELD_OF_VIEW);
			updateEyes();
		}
	}
	
	private void updateEyes() {
		
	}
}
